#include "descriptor/descriptor.h"

int main(void) {
ITEM fanalinoint1, fanalinoint2, finestrasfondo, pavimento, scatola1, scatola2, scatola3, soffitto ;

ITEM cruscotto, finestra, finiture, gomme, lamiere, maniglie, meccanismo, mensole, muso, pareti, pedaledestro, pedalesinistro, porta, raggianterioridx, raggianteriorisn, raggiposterioridx, raggiposteriorisn, sedile, seggiolino, telaioinferiore, telaiosuperiore, telaioruote, tettoriscio, volante, volantefinto;


ITEM a_finestra, colore_giallo, colore_grigio, colore_blu, colore_fanale, colore_nero, legno, metallo, metalloscuro;

ITEM scena;
	
	
/***ambiente***/
  
  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(16.16,15.90,9.39,1,1,1,3.89,20, "luce1");
  create_point_light(12,-12,9,1,1,1,4,20, "luce2");
  create_point_light(2.33,-0.25,16.21,1,1,1,3.89,25, "luce3");
  create_warn_light(0,2.6,-0.354,-0.046,-0.987,-0.153,1,1,1,1,0,0,20,TRUE,0,0,0,0, "lucefinestra");


/***attributi***/

a_finestra = create_attribute("a_finestra");
	set_color(a_finestra,0.676,0.861,0.953,1,1);
	set_reflectivity(a_finestra,0.28,2);

colore_giallo = create_attribute("colore_giallo");
  	set_color(colore_giallo,1,1,0,0.2,0.8);
  	set_reflectivity(colore_giallo,0.3,10);

colore_grigio=create_attribute("colore_grigio");
	set_color(colore_grigio,164.0/255.0,165.0/255.0,160.0/255.0,0.7,0.6);
	set_reflectivity(colore_grigio,1,2);

colore_blu = create_attribute("colore_blu");
	set_color(colore_blu,0,0,1,0.5,0.5);
	set_reflectivity(colore_blu,0.3,10);

colore_fanale=create_attribute("colore_fanale");
	set_color(colore_fanale,1,1,1,1,1);
	set_reflectivity(colore_fanale, 1,0);
	 set_transparency(colore_fanale,0.87,0.68,1,1.2);

colore_nero = create_attribute("colore_nero");
  	set_color(colore_nero,0,0,0,0.5,0.5);
  	set_reflectivity(colore_nero,0.24,2);

legno = create_attribute("legno");
 	set_color(legno,0.97,0.8,0.41,0.6,0.7);
  	set_reflectivity(legno,0.24,2);

metallo = create_attribute("metallo");
	set_color(metallo,0.654,0.654,0.556,0.5,0.5);
	set_reflectivity(metallo,0.5,2);

metalloscuro = create_attribute("metalloscuro");
	set_color(metalloscuro,0.36,0.36,0.40,0.5,0.5);
	set_reflectivity(metalloscuro,0.5,3);



/***caricamento superfici***/

fanalinoint1 = read_nurbs("fanalinoint1.db");
	set_attribute(fanalinoint1, colore_fanale);

fanalinoint2 = read_nurbs("fanalinoint2.db");
	set_attribute(fanalinoint2, colore_fanale);

finestrasfondo = read_nurbs("finestrasfondo.db");
	set_attribute(finestrasfondo, a_finestra);

pavimento = read_nurbs("pavimento.db");
	set_domain_texture(pavimento, legno, "pavimento.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);

scatola1 = read_nurbs("scatola1.db");
	set_domain_texture(scatola1, legno, "scatola1.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);

scatola2 = read_nurbs("scatola2.db");
	set_domain_texture(scatola2, legno, "scatola2.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);

scatola3 = read_nurbs("scatola3.db");
	set_domain_texture(scatola3, legno, "scatola3.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);

soffitto = read_nurbs("soffitto.db");
	//set_attribute(soffitto, colore_grigio);
	set_domain_texture(soffitto, legno, "pareti.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);

/***caricamento oggetti***/

cruscotto = read_obj("cruscotto.obj","cruscotto");
	set_attribute(cruscotto, colore_blu);

finestra = read_obj("finestra.obj","finestra");
	set_attribute(finestra, legno);

finiture = read_obj("finiture.obj", "finiture");
	set_attribute(finiture, metalloscuro);

gomme = read_obj("gomme.obj","gomme");
	set_attribute(gomme, colore_nero);


lamiere = read_obj("lamiere.obj", "lamiere");
	set_attribute(lamiere, metallo);

maniglie = read_obj("maniglie.obj","maniglie");
	set_attribute(maniglie, metallo);

mensole = read_obj("mensole.obj","mensole");
	set_attribute(mensole, legno);


muso = read_obj("muso.obj","muso");
	set_attribute(muso, colore_blu);

meccanismo = read_obj("meccanismo.obj","meccanismo");
	set_attribute(meccanismo,metallo);

pareti = read_obj("pareti.obj","pareti");
	set_domain_texture(pareti, legno, "pareti.hr", 0, 1, 0, 1, TRUE, 0.1, 0.8);


pedaledestro = read_obj("pedaledestro.obj", "pedale1");
	set_attribute(pedaledestro, metallo);

pedalesinistro = read_obj("pedalesinistro.obj", "pedale2");
	set_attribute(pedalesinistro, metallo);

porta = read_obj("porta.obj","porta");
	set_attribute(porta,legno);

raggianterioridx = read_obj("raggianterioridx.obj", "raggi1");
	set_attribute(raggianterioridx, metallo);

raggianteriorisn = read_obj("raggianteriorisn.obj", "raggi2");
	set_attribute(raggianteriorisn, metallo);

raggiposterioridx = read_obj("raggiposterioridx.obj", "raggi3");
	set_attribute(raggiposterioridx, metallo);
	
raggiposteriorisn = read_obj("raggiposteriorisn.obj", "raggi4");
	set_attribute(raggiposteriorisn, metallo);

sedile = read_obj("sedile.obj", "sedile");
	set_attribute(sedile, colore_nero);

seggiolino = read_obj("seggiolino.obj", "seggiolino");
	set_attribute(seggiolino, colore_giallo);

telaioinferiore = read_obj("telaioinferiore.obj","telaioinf");
	set_attribute(telaioinferiore, colore_blu);

telaiosuperiore = read_obj("telaiosuperiore.obj","telaiosup");
	set_attribute(telaiosuperiore, metallo);

telaioruote = read_obj("telaioruote.obj", "telaioruote");
	set_attribute(telaioruote, metalloscuro);




tettoriscio = read_obj("tettoriscio.obj","tetto");
	set_attribute(tettoriscio, colore_giallo);

volante = read_obj("volante.obj","volante");
	set_attribute(volante, colore_nero);

volantefinto = read_obj("volantefinto.obj","volantefinto");
	set_attribute(volantefinto,colore_nero);


/***caricamento scena***/

scena = create_list(fanalinoint1, "scena");
/*superfici*/
scena = insert_in_list(scena, fanalinoint1);
scena = insert_in_list(scena, fanalinoint2);
scena = insert_in_list(scena, finestrasfondo);
scena = insert_in_list(scena, pavimento);
scena = insert_in_list(scena, scatola1);
scena = insert_in_list(scena, scatola2);
scena = insert_in_list(scena, scatola3);
scena = insert_in_list(scena, soffitto);
/*oggetti*/
scena = insert_in_list(scena, cruscotto);
scena = insert_in_list(scena, finestra);
scena = insert_in_list(scena, finiture);
scena = insert_in_list(scena, gomme);
scena = insert_in_list(scena, lamiere);
scena = insert_in_list(scena, maniglie);
scena = insert_in_list(scena, meccanismo);
scena = insert_in_list(scena, mensole);
scena = insert_in_list(scena, muso);
scena = insert_in_list(scena, pareti);
scena = insert_in_list(scena, pedaledestro);
scena = insert_in_list(scena, pedalesinistro);
scena = insert_in_list(scena, porta);
scena = insert_in_list(scena, raggianterioridx);
scena = insert_in_list(scena, raggianteriorisn);
scena = insert_in_list(scena, raggiposterioridx);
scena = insert_in_list(scena, raggiposteriorisn);
scena = insert_in_list(scena, sedile);
scena = insert_in_list(scena, seggiolino);
scena = insert_in_list(scena, telaioinferiore);
scena = insert_in_list(scena, telaioruote);
scena = insert_in_list(scena, telaiosuperiore);
scena = insert_in_list(scena, tettoriscio);
scena = insert_in_list(scena, volante);
scena = insert_in_list(scena, volantefinto);




save_scene("riscio.md", "riscio", scena);


return(0);
}
